#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

new Handle:k_iDefault = INVALID_HANDLE;
new Handle:h_iSkyStyle = INVALID_HANDLE;
new Handle:m_iMapStyleMenu = INVALID_HANDLE;
new Handle:m_iDarknessMenu = INVALID_HANDLE;
new Handle:m_iSkyMenu = INVALID_HANDLE;

public Plugin:myinfo =
{
	name = "Map Styles",
	author = "Vlladz",
	description = "Map/sky styles, darkness...",
	version = "1.0",
	url = "http://www.sourcemod.net/"
}

public OnPluginStart()
{
	h_iSkyStyle = FindConVar("sv_skyname");
	RegAdminCmd("mapstyle", Command_MapStyle, ADMFLAG_GENERIC, "[SM Mapstyle] Change map darkness and sky.");
	CreateMenus();

	k_iDefault = CreateKeyValues("MapStyle");
	FileToKeyValues(k_iDefault, "cfg/sourcemod/mapstyle.txt");
	KvJumpToKey(k_iDefault, "default");
}

public CreateMenus()
{
	CreateMapStyleMenu();
	CreateDarknessMenu();
	CreateSkyMenu();
}

public CreateMapStyleMenu()
{
	m_iMapStyleMenu = CreateMenu(MapStyleMenuHandler);
	SetMenuTitle(m_iMapStyleMenu, "Map Styles");
	AddMenuItem(m_iMapStyleMenu, "1", "Set map darkness");
	AddMenuItem(m_iMapStyleMenu, "2", "Set map sky");
	SetMenuExitButton(m_iMapStyleMenu, true);
}

public CreateDarknessMenu()
{
	m_iDarknessMenu = CreateMenu(DarknessMenuHandler);
	SetMenuTitle(m_iDarknessMenu, "Map Darkness");
	AddMenuItem(m_iDarknessMenu, "1", "Level: 1");
	AddMenuItem(m_iDarknessMenu, "2", "Level: 2");
	AddMenuItem(m_iDarknessMenu, "3", "Level: 3");
	AddMenuItem(m_iDarknessMenu, "4", "Level: 4");
	AddMenuItem(m_iDarknessMenu, "5", "Level: 5");
	AddMenuItem(m_iDarknessMenu, "6", "Level: 6");
	AddMenuItem(m_iDarknessMenu, "7", "Level: 7");
	AddMenuItem(m_iDarknessMenu, "8", "Level: 8");
	AddMenuItem(m_iDarknessMenu, "9", "Level: 9");
	AddMenuItem(m_iDarknessMenu, "10", "Level: 10");
	AddMenuItem(m_iDarknessMenu, "11", "Level: 11");
	AddMenuItem(m_iDarknessMenu, "12", "Level: 12");
	AddMenuItem(m_iDarknessMenu, "13", "Level: 13");
	AddMenuItem(m_iDarknessMenu, "14", "Level: 14");
	AddMenuItem(m_iDarknessMenu, "15", "Level: 15");
	AddMenuItem(m_iDarknessMenu, "16", "Level: 16");
	AddMenuItem(m_iDarknessMenu, "17", "Level: 17");
	AddMenuItem(m_iDarknessMenu, "18", "Level: 18");
	AddMenuItem(m_iDarknessMenu, "19", "Level: 19");
	AddMenuItem(m_iDarknessMenu, "20", "Level: 20");
	AddMenuItem(m_iDarknessMenu, "21", "Level: 21");
	AddMenuItem(m_iDarknessMenu, "22", "Level: 22");
	AddMenuItem(m_iDarknessMenu, "23", "Level: 23");
	AddMenuItem(m_iDarknessMenu, "24", "Level: 24");
	AddMenuItem(m_iDarknessMenu, "25", "Level: 25");
	AddMenuItem(m_iDarknessMenu, "26", "Level: 26");
	SetMenuExitButton(m_iDarknessMenu, true);
}

public CreateSkyMenu()
{
	m_iSkyMenu = CreateMenu(SkyMenuHandler);
	SetMenuTitle(m_iSkyMenu, "Map Sky Styles");

	new Handle:d_iSkyTempFolder = INVALID_HANDLE;
	decl String:SkyTempName[256];
	new FileType:Type;

	d_iSkyTempFolder = OpenDirectory("../cstrike/materials/skybox");
	while(ReadDirEntry(d_iSkyTempFolder, SkyTempName, sizeof(SkyTempName), Type))
	{
		if (Type == FileType_File)
		{
			if (StrContains(SkyTempName, "up.vtf", false) != -1)
			{
				strcopy(SkyTempName, strlen(SkyTempName) - 6 + 1, SkyTempName);
				AddMenuItem(m_iSkyMenu, SkyTempName, SkyTempName);
			}
		}
	}

	CloseHandle(d_iSkyTempFolder);
	d_iSkyTempFolder = INVALID_HANDLE;

	d_iSkyTempFolder = OpenDirectory("../hl2/materials/skybox");
	while(ReadDirEntry(d_iSkyTempFolder, SkyTempName, sizeof(SkyTempName), Type))
	{
		if (Type == FileType_File)
		{
			if (StrContains(SkyTempName, "up.vtf", false) != -1)
			{
				strcopy(SkyTempName, strlen(SkyTempName) - 6 + 1, SkyTempName);
				AddMenuItem(m_iSkyMenu, SkyTempName, SkyTempName);
			}
		}
	}

	CloseHandle(d_iSkyTempFolder);
	d_iSkyTempFolder = INVALID_HANDLE;

	SetMenuExitButton(m_iSkyMenu, true);
}

public MapStyleMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0: DisplayMenu(m_iDarknessMenu, param1, MENU_TIME_FOREVER);
			case 1: DisplayMenu(m_iSkyMenu, param1, MENU_TIME_FOREVER);
		}
	}
}

public DarknessMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0: KvSetString(k_iDefault, "lightstyle", "a");
			case 1: KvSetString(k_iDefault, "lightstyle", "b");
			case 2: KvSetString(k_iDefault, "lightstyle", "c");
			case 3: KvSetString(k_iDefault, "lightstyle", "d");
			case 4: KvSetString(k_iDefault, "lightstyle", "e");
			case 5: KvSetString(k_iDefault, "lightstyle", "f");
			case 6: KvSetString(k_iDefault, "lightstyle", "g");
			case 7: KvSetString(k_iDefault, "lightstyle", "h");
			case 8: KvSetString(k_iDefault, "lightstyle", "i");
			case 9: KvSetString(k_iDefault, "lightstyle", "j");
			case 10: KvSetString(k_iDefault, "lightstyle", "k");
			case 11: KvSetString(k_iDefault, "lightstyle", "l");
			case 12: KvSetString(k_iDefault, "lightstyle", "m");
			case 13: KvSetString(k_iDefault, "lightstyle", "n");
			case 14: KvSetString(k_iDefault, "lightstyle", "o");
			case 15: KvSetString(k_iDefault, "lightstyle", "p");
			case 16: KvSetString(k_iDefault, "lightstyle", "q");
			case 17: KvSetString(k_iDefault, "lightstyle", "r");
			case 18: KvSetString(k_iDefault, "lightstyle", "s");
			case 19: KvSetString(k_iDefault, "lightstyle", "t");
			case 20: KvSetString(k_iDefault, "lightstyle", "u");
			case 21: KvSetString(k_iDefault, "lightstyle", "v");
			case 22: KvSetString(k_iDefault, "lightstyle", "w");
			case 23: KvSetString(k_iDefault, "lightstyle", "x");
			case 24: KvSetString(k_iDefault, "lightstyle", "y");
			case 25: KvSetString(k_iDefault, "lightstyle", "z");
		}
		PrintToChat(param1, "\x04[SM MapStyle] \x01Map darkness will be changed the next time server changes level!");
	}
}

public SkyMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		decl String:MenuItemName[256];
		GetMenuItem(menu, param2, MenuItemName, sizeof(MenuItemName));
		KvSetString(k_iDefault, "skystyle", MenuItemName);
		PrintToChat(param1, "\x04[SM MapStyle] \x01Sky style will be changed the next time server changes level!");
	}
}

public OnMapStart()
{
	ExecConfig();

	decl String:lightstyle[3];
	decl String:skystyle[256];
	KvGetString(k_iDefault, "lightstyle", lightstyle, sizeof(lightstyle));
	KvGetString(k_iDefault, "skystyle", skystyle, sizeof(skystyle));

	SetLightStyle(0, lightstyle);
	SetConVarString(h_iSkyStyle, skystyle);
}

public ExecConfig()
{
	decl String:CfgFilePath[512];
	Format(CfgFilePath, sizeof(CfgFilePath), "cfg/sourcemod/mapstyle.cfg");
	new Handle:h_iCfgFile = OpenFile(CfgFilePath, "r");

	decl String:buffer[512];
	while(ReadFileLine(h_iCfgFile, buffer, sizeof(buffer)))
	{
		TrimString(buffer);

		new String:comment[5];
		strcopy(comment, 3, buffer);
		if (!StrEqual(comment, "//", true))
		{
			decl String:file[512];
			Format(file, sizeof(file), "materials/skybox/%s", buffer);

			PrecacheModel(file, true);
			AddFileToDownloadsTable(file);
		}
	}

	CloseHandle(h_iCfgFile);
	h_iCfgFile = INVALID_HANDLE;
}

public Action:Command_MapStyle(client, args)
{
	DisplayMenu(m_iMapStyleMenu, client, MENU_TIME_FOREVER);
	return Plugin_Handled;
}